<?php

class BookmarksManager
{
	var $currentUser;
	var $bookmarksFolder = "bookmarks";
	
	function BookmarksManager($user)
	{
		$this->currentUser = $user;
	}
		
	function addBookMark($path)
	{
		$currentBMarks = $this->getBookMarks();
		if(in_array($path, $currentBMarks)) return;
		$fp = fopen($this->bookmarksFolder."/".$this->currentUser.".txt", "a");
		fwrite($fp, $path."\n");
		fclose($fp);
	}
	
	function getBookMarks()
	{
		$bMarks = array();
		if(is_file($this->bookmarksFolder."/".$this->currentUser.".txt"))
		{
			$file = file($this->bookmarksFolder."/".$this->currentUser.".txt");
			foreach ($file as $index => $bookmark)
			{
				$bookmark = str_replace("\n", "", $bookmark);
				if(trim($bookmark) != "")
				{
					$bMarks[] = $bookmark;
				}
			}
		}
		return $bMarks;
	}
	
	function removeBookMark($path)
	{	
		$currentBMarks = $this->getBookMarks();
		if(!in_array($path, $currentBMarks))
		{
			return ;
		}
		$newBookMarks = array();
		foreach ($currentBMarks as $bookmark)
		{
			if($bookmark == $path || trim($bookmark) == "") continue;
			$newBookMarks[] = $bookmark;
		}
		unlink($this->bookmarksFolder."/".$this->currentUser.".txt");	
		$fp = fopen($this->bookmarksFolder."/".$this->currentUser.".txt", "w");
		fwrite($fp, join("\n", $newBookMarks)."\n");
		fclose($fp);
	}

	function getCurrentUser()
	{
		return $this->currentUser;
	}
	
}

?>