function InfoPanel(htmlElement)
{
	this.htmlElement = $(htmlElement);
	this.setContent('<br><br><center><i>No Selection</i></center>');	
}

InfoPanel.prototype.update = function()
{	
	var userSelection = ajaxplorer.getFilesList().getUserSelection();
	if(userSelection.isEmpty())
	{
		this.setContent('<br><br><center><i>No Selection</i></center>');
		return;
	}
	if(!userSelection.isUnique())
	{
		this.setContent(userSelection.getFileNames().length + ' files selected.');
		return;
	}
	if(userSelection.isImage())
	{
		this.displayImageInfo(userSelection.getUniqueItem());
		return;
	}
	var uniqItem = userSelection.getUniqueItem();
	if(uniqItem.getAttribute('is_mp3') == '1')
	{
		this.displayMP3Info(uniqItem);
		return;
	}
	this.displayFileInfo(uniqItem);
}

InfoPanel.prototype.setContent = function(sHtml)
{
	this.htmlElement.innerHTML = sHtml;
}

InfoPanel.prototype.displayImageInfo = function(imgData)
{
	var baseUrl = "content.php?action=image_proxy&get_thumb=true&fic=";
	var imgUrl = baseUrl + imgData.getAttribute("filename");
	var fileName = getBaseName(imgData.getAttribute("filename"));
	var imageType = imgData.getAttribute("image_type");
	var imageDimension = imgData.getAttribute("image_width") + 'px X ' + imgData.getAttribute("image_height")+'px';
	var fileSize = imgData.getAttribute("filesize");
	
	var width = imgData.getAttribute("image_width");
	var height = imgData.getAttribute("image_height");
	
	var newHeight = 150;
	if(height < newHeight) newHeight = height;
	var newWidth = newHeight*width/height;
	var dimAttr = 'height="'+newHeight+'"';
	if(newWidth > $('info_panel').getWidth() - 16) dimAttr = 'width="100%"';
	
	var tString = '<div style="padding:10px;"><center style="border:1px solid #79f;"><img src="#{url}" #{dimattr}></center>';
	tString += '<br><b>Name</b> : #{filename}';
	tString += '<br><b>Type</b> : #{imagetype}';
	tString += '<br><b>Dimensions</b> : #{dimension}';
	tString += '<br><b>Size</b> : #{filesize}';
	tString += '<div style="text-align:right;padding-top:5px;"><a href="#" onclick="ajaxplorer.actionBar.fireAction(\'edit\'); return false;">View Larger Image</a> | <a href="#" onclick="ajaxplorer.actionBar.fireAction(\'download\'); return false;">Download</a></div>';
	tString += '</div>';
	var template = new Template(tString);
	this.setContent(template.evaluate({url:imgUrl, dimattr:dimAttr, filename:fileName, imagetype:imageType, dimension:imageDimension,filesize:fileSize}));
}

InfoPanel.prototype.displayFileInfo = function(fileData)
{
	var fileName = getBaseName(fileData.getAttribute("filename"));
	var fileType = fileData.getAttribute("mimetype");
	var fileSize = fileData.getAttribute("filesize");
	var modifTime = fileData.getAttribute("modiftime");
	var is_file = (fileData.getAttribute("is_file")=='oui'?true:false);
	var is_editable = (fileData.getAttribute("is_editable")=='1'?true:false);
	
	var tString = '<div style="padding:10px;">';
	if(!is_file){
		tString += '<div class="folderImage"><img src="images/crystal/folder_yellow_64.png" height="64" width="64"></div>';
	}
	else{
		tString += '<div class="folderImage"><img src="images/crystal/info_64.png" height="64" width="64"></div>';
	}
	
	tString += '<b>Name</b> : '+fileName;
	if(is_file){
		tString += '<br><b>Size</b> : '+fileSize;
		tString += '<br><b>Type</b> : '+fileType;
	}
	tString += '<br><b>Last Modif : </b> : '+ modifTime;
	if(is_file){
		tString += '<div style="text-align:right;padding-top:5px;">';
		if(is_editable){
			tString += '<a href="#" onclick="ajaxplorer.actionBar.fireAction(\'edit\'); return false;">Edit online</a> | ';
		}
		tString += '<a href="#" onclick="ajaxplorer.actionBar.fireAction(\'download\'); return false;">Download</a>';
		tString += '</div>';
	}
	tString += '</div>';
	this.setContent(tString);
}

InfoPanel.prototype.displayMP3Info = function(fileData)
{
	var fileName = getBaseName(fileData.getAttribute("filename"));
	var fileType = fileData.getAttribute("mimetype");
	var fileSize = fileData.getAttribute("filesize");
	var modifTime = fileData.getAttribute("modiftime");
	
	var template = new Template('<object type="application/x-shockwave-flash" data="include/flash/dewplayer-mini.swf?mp3=#{mp3_url}&amp;bgcolor=FFFFFF" width="150" height="20"><param name="wmode" value="transparent"><param name="movie" value="include/flash/dewplayer-mini.swf?mp3=#{mp3_url}&amp;bgcolor=FFFFFF" /></object>');
	
	var tString = '<div style="padding:10px;">';
	tString += '<div id="mp3_container" style="border:1px solid #79f; text-align:center; padding:5px; width:160px;">'+template.evaluate({mp3_url:'content.php?action=mp3_proxy%26fic=' + fileData.getAttribute("filename")})+'</div>';
	tString += '<br><b>Name</b> : '+fileName;
	tString += '<br><b>Type</b> : '+fileType;
	tString += '<br><b>Size</b> : '+fileSize;
	tString += '<br><b>Last Modif : </b> : '+ modifTime;
	tString += '<div style="text-align:right;padding-top:5px;">';
	tString += '<a href="#" onclick="ajaxplorer.actionBar.fireAction(\'download\'); return false;">Download</a>';
	tString += '</div>';
	tString += '</div>';
	this.setContent(tString);	
}

InfoPanel.prototype.displayFlashPlayer = function(fileName)
{
	var baseUrl = 'content.php?action=mp3_proxy%26fic=' + fileName;
    var FO = { movie:"include/flash/dewplayer-mini.swf?mp3="+baseUrl, width:"150", height:"20"};
    UFO.create(FO, 'mp3_container');
}